﻿// -*- C++ -*-
// <rtc-template block="description">
/*!
 * @file  HumanProtectionTest.cpp
 * @brief ModuleDescription (test code)
 *
 */
// </rtc-template>

#include "HumanProtectionTest.h"

// Module specification
// <rtc-template block="module_spec">
#if RTM_MAJOR_VERSION >= 2
static const char* const humanprotection_spec[] =
#else
static const char* humanprotection_spec[] =
#endif
  {
    "implementation_id", "HumanProtectionTest",
    "type_name",         "HumanProtectionTest",
    "description",       "ModuleDescription",
    "version",           "2.0.0",
    "vendor",            "meijo univ.",
    "category",          "Robot",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    "conf.default.Judge_Parameter", "1000",

    // Widget
    "conf.__widget__.Judge_Parameter", "text",
    // Constraints

    "conf.__type__.Judge_Parameter", "float",

    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
HumanProtectionTest::HumanProtectionTest(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_Human_PoseOut("Human_Pose", m_Human_Pose),
    m_Stop_CommandIn("Stop_Command", m_Stop_Command)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
HumanProtectionTest::~HumanProtectionTest()
{
}



RTC::ReturnCode_t HumanProtectionTest::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("Stop_Command", m_Stop_CommandIn);
  
  // Set OutPort buffer
  addOutPort("Human_Pose", m_Human_PoseOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  bindParameter("Judge_Parameter", m_Judge_Parameter, "1000");
  // </rtc-template>
  
  return RTC::RTC_OK;
}


RTC::ReturnCode_t HumanProtectionTest::onFinalize()
{
  return RTC::RTC_OK;
}


//RTC::ReturnCode_t HumanProtectionTest::onStartup(RTC::UniqueId /*ec_id*/)
//{
//  return RTC::RTC_OK;
//}


//RTC::ReturnCode_t HumanProtectionTest::onShutdown(RTC::UniqueId /*ec_id*/)
//{
//  return RTC::RTC_OK;
//}


RTC::ReturnCode_t HumanProtectionTest::onActivated(RTC::UniqueId /*ec_id*/)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t HumanProtectionTest::onDeactivated(RTC::UniqueId /*ec_id*/)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t HumanProtectionTest::onExecute(RTC::UniqueId /*ec_id*/)
{
  return RTC::RTC_OK;
}


//RTC::ReturnCode_t HumanProtectionTest::onAborting(RTC::UniqueId /*ec_id*/)
//{
//  return RTC::RTC_OK;
//}


//RTC::ReturnCode_t HumanProtectionTest::onError(RTC::UniqueId /*ec_id*/)
//{
//  return RTC::RTC_OK;
//}


//RTC::ReturnCode_t HumanProtectionTest::onReset(RTC::UniqueId /*ec_id*/)
//{
//  return RTC::RTC_OK;
//}


//RTC::ReturnCode_t HumanProtectionTest::onStateUpdate(RTC::UniqueId /*ec_id*/)
//{
//  return RTC::RTC_OK;
//}


//RTC::ReturnCode_t HumanProtectionTest::onRateChanged(RTC::UniqueId /*ec_id*/)
//{
//  return RTC::RTC_OK;
//}


bool HumanProtectionTest::runTest()
{
    return true;
}


extern "C"
{
 
  void HumanProtectionTestInit(RTC::Manager* manager)
  {
    coil::Properties profile(humanprotection_spec);
    manager->registerFactory(profile,
                             RTC::Create<HumanProtectionTest>,
                             RTC::Delete<HumanProtectionTest>);
  }
  
}
