#!/usr/bin/env python

import rospy
import actionlib
import moveit_commander

from std_msgs.msg import Int8
from move_base_msgs.msg import MoveBaseAction, MoveBaseGoal

client = actionlib.SimpleActionClient('move_base', MoveBaseAction)

def callback(message):
    rospy.loginfo(message.data)
    if message.data == 1:
        print(1)
        for pose in waypoints_2:
            goal = goal_pose(pose)
            client.send_goal(goal)
            client.wait_for_result()
        while True:
            pass
    elif message.data == 0:
        print(0)

waypoints_1 = [
    [(1.23, 0.15, 0), (0.0, 0.0, 0.0, 1.0)]
]

waypoints_2 = [
    [(0.0, 0.0, 0.0),(0.0, 0.0, 0.0, 1.0)]
]

waypoints_3 = [
    [(-0.35, 0.90, 0.0),(0.0, 0.0, 0.0, 1.0)]
]

def goal_pose(pose):
    goal_pose = MoveBaseGoal()
    goal_pose.target_pose.header.frame_id = 'map'
    goal_pose.target_pose.pose.position.x = pose[0][0]
    goal_pose.target_pose.pose.position.y = pose[0][1]
    goal_pose.target_pose.pose.position.z = pose[0][2]
    goal_pose.target_pose.pose.orientation.x = pose[1][0]
    goal_pose.target_pose.pose.orientation.y = pose[1][1]
    goal_pose.target_pose.pose.orientation.z = pose[1][2]
    goal_pose.target_pose.pose.orientation.w = pose[1][3]
    return goal_pose

def main():

    rospy.init_node('move_node')
    
    # client = actionlib.SimpleActionClient('move_base', MoveBaseAction)


    client.wait_for_server()
    for pose in waypoints_1:
        goal = goal_pose(pose)
        client.send_goal(goal)
        client.wait_for_result()
    
    rospy.sleep(5)

    sub = rospy.Subscriber('stop_cmd', Int8 , callback)
    rospy.spin()

    # for pose in waypoints_2:
    #     goal = goal_pose(pose)
    #     client.send_goal(goal)
    #     client.wait_for_result()

    # for pose in waypoints_3:
    #     goal = goal_pose(pose)
    #     client.send_goal(goal)
    #     client.wait_for_result()

if __name__ == '__main__':
    try:
        main()
    except rospy.ROSInterruptException:
        pass
